IMPORT("BlockEngine");
IMPORT("Patched");
var items = {};
var blocks = {};
var tool_tip = __config__.get("tool_tip") || "§r§7{strId}:{id}\n§9{mod}§r";
var _mod = null;
var ToolTip = {};
ModAPI.addAPICallback("CoreUtility", function(api){
ToolTip = api.ToolTip;
});
Patched.patchedToObject(Item, "createItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.BEFORE);
Patched.patchedToObject(Item, "createFoodItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.BEFORE);
Patched.patchedToObject(Item, "createArmorItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.BEFORE);
Patched.patchedToObject(Item, "createThrowableItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.BEFORE);
Patched.patchedToObject(Item, "createArmorItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.BEFORE);
Patched.patchedToObject(Block, "createBlock", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        blocks[controller.getArguments()[0]] = mod;
    else
        blocks[controller.getArguments()[0]] = _mod;
}, Flags.BEFORE);
Patched.patchedToObject(Block, "createBlockWithRotation", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        blocks[controller.getArguments()[0]] = mod;
    else
        blocks[controller.getArguments()[0]] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(ItemRegistry, "registerItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0].stringID] = mod;
    else
        items[controller.getArguments()[0].stringID] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(ItemRegistry, "createItem", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(ItemRegistry, "createFood", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(ItemRegistry, "createArmor", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(ItemRegistry, "createTool", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        items[controller.getArguments()[0]] = mod;
    else
        items[controller.getArguments()[0]] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(BlockRegistry, "registerBlock", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        blocks[controller.getArguments()[0].stringID] = mod;
    else
        blocks[controller.getArguments()[0].stringID] = _mod;
}, Flags.AFTER);
Patched.patchedToObject(BlockRegistry, "createBlock", function (controller) {
    var mod = controller.getContextValue("__name__");
    if (_mod === null && mod instanceof java.lang.String)
        blocks[controller.getArguments()[0]] = mod;
    else
        blocks[controller.getArguments()[0]] = _mod;
}, Flags.AFTER);
var ItemInformation = {
    handlers: [],
    addHandler: function (obj) {
        this.handlers.push(obj);
    },
    startModLoad: function (name) {
        _mod = name;
    },
    endModLoad: function () {
        _mod = null;
    }
};
ItemInformation.addHandler({
    addToolTip: function (tip, id, stringID, mod, items) {
        var name = tip + tool_tip;
        name = name.replace("{id}", String(id));
        name = name.replace("{strId}", stringID);
        name = name.replace("{mod}", mod);
        return name;
    }
});
function register(obj, types) {
    var keys = Object.keys(obj);
    for (var i in keys) {
        var key = keys[i];
        var id = obj[key];
        var name = "";
        var mod = String(types[key] || "minecraft");
        mod = mod[0].toUpperCase() + mod.substring(1);
        for (var i_1 in ItemInformation.handlers) {
            var obj_1 = ItemInformation.handlers[i_1];
            if (obj_1.addDynamicPre)
                ToolTip.addDynamicPre(id, -1, obj_1.addDynamicPre);
            if (obj_1.addDynamicPost)
                ToolTip.addDynamicPost(id, -1, obj_1.addDynamicPost);
            var res = obj_1.addToolTip(name, id, key, mod, obj_1);
            if (res != name)
                name = res + (ItemInformation.handlers.length > 1 && ItemInformation.handlers.length - 1 != i_1 && (obj_1.is === undefined || obj_1.is(name, id, key, mod, obj_1)) ? "\n" : "");
        }
        ToolTip.addToolTip(id, -1, name);
    }
}
Callback.addCallback("PostLoaded", function () {
    register(ItemID, items);
    register(BlockID, blocks);
    register(VanillaItemID, {});
    register(VanillaBlockID, {});
});
ModAPI.registerAPI("ItemInformation", {
    items: items,
    blocks: blocks,
    ItemInformation: ItemInformation,
    ToolTip: ToolTip,
    requireGlobal: function (cmd) {
        return eval(cmd);
    }
});
